#ifndef _TInterpol_
#define _TInterpol_

#include <math.h>

class TInterpol
{
  public:
    TInterpol(void);               //
    ~TInterpol(void);              //
    double GetX(int i);            // i-  x
    double GetY(int i);            // i-  y
    double GetPn(double x);



  private:
    double GetAk(int k);
    double GetBk(int k);

    double *matrx,                 //  x
           *matry;                 //  y
};

//------------------------------------------------------------------------------

TInterpol::TInterpol(void)
{
  matrx = new double[21];
  matry = new double[21];

  for(int i = 0; i < 21; i++) matrx[i] = (2*M_PI*i) / 21;

  matry[0] = -1.24;   matry[11] = -1.28;
  matry[1] = -1.17;   matry[12] = -1.32;
  matry[2] = -1.08;   matry[13] = -1.34;
  matry[3] = -0.96;   matry[14] = -1.36;
  matry[4] = -0.84;   matry[15] = -1.37;
  matry[5] = -0.79;   matry[16] = -1.37;
  matry[6] = -0.80;   matry[17] = -1.36;
  matry[7] = -0.90;   matry[18] = -1.35;
  matry[8] = -1.10;   matry[19] = -1.33;
  matry[9] = -1.21;   matry[20] = -1.30;
  matry[10] = -1.02;
}

TInterpol::~TInterpol(void)
{
  delete[] matrx;
  delete[] matry;
}

double TInterpol::GetX(int i)
{
  return matrx[i];
}

double TInterpol::GetY(int i)
{
  return matry[i];
}

double TInterpol::GetAk(int k)
{
  double S = 0;

  for(int i = 0; i < 21; i++)
    S += matry[i] * cos((2 * M_PI * k * i) / 21);

  return (S / 21);
}

double TInterpol::GetBk(int k)
{
  double S = 0;

  for(int i = 0; i < 21; i++)
    S += matry[i] * sin((2 * M_PI * k * i) / 21);

  return (S / 21);
}

double TInterpol::GetPn(double x)
{
  double a0 = 0, S = 0;

  for(int i = 0; i < 21; i++)
    a0 += matry[i];
  a0 /= 21;

    for(int k = 1; k < 11; k++)
      S += ((GetAk(k) * cos(k * x)) + (GetBk(k) * sin(k * x)));

    return (a0 + (2 * S));
}

#endif
